varying highp vec2  Texcoord0;

uniform highp float Radius;
uniform highp vec2  InputSize;
uniform highp vec2  OutputSize;

uniform highp sampler2D   SAT;

void main()
{
    highp float radius = Radius;
    
    highp float w = OutputSize.x;
    highp float h = OutputSize.y;
    
    highp float w_raw = InputSize.x;
    highp float h_raw = InputSize.y;
    
    highp vec2 texelcoord = vec2(floor(w_raw*Texcoord0.r)+0.5, floor(h_raw*Texcoord0.g)+0.5);
    
    if(radius<1.0)
    {
        gl_FragColor = texture2D(SAT, Texcoord0);
        
        return;
    }
    
    radius = floor(radius);
    
    highp float startx = max(0.0,texelcoord.x-radius);
    highp float starty = max(0.0,texelcoord.y-radius);
    highp float endx = min(w,texelcoord.x+radius);
    highp float endy = min(h,texelcoord.y+radius);
    
    highp float num = (endx-startx)*(endy-starty);
    
    startx  =   startx/w_raw;
    endx    =   endx/w_raw;
    starty  =   starty/h_raw;
    endy    =   endy/h_raw;
    
    highp vec4 A = texture2D(SAT, vec2(startx, endy));
    highp vec4 B = texture2D(SAT, vec2(endx, starty));
    highp vec4 C = texture2D(SAT, vec2(startx, starty));
    highp vec4 D = texture2D(SAT, vec2(endx, endy));
    
    highp vec4 sum = D+C-A-B;
    
    gl_FragColor = sum / num;
}

