varying highp vec2  Texcoord0;

uniform highp float Radius;
uniform highp vec2  OutputSize;

uniform sampler2D   Texture;

void main()
{
    highp vec4  finalValue = vec4(0.0);
    
    highp float totalWeight = 0.0;
    
    highp float varianceDist  = Radius * Radius / 4.5;
    
    for(highp float y = -Radius; y <= Radius; y++)
    {
        for(highp float x = -Radius; x <= Radius; x++)
        {
            highp vec2 coord = vec2((OutputSize.x - 1.0) * Texcoord0.x + x, (OutputSize.y - 1.0) * Texcoord0.y + y);

            if( coord.x < 0.0 || coord.x >= OutputSize.x || coord.y < 0.0 || coord.y >= OutputSize.y)
            {
                continue;
            }
            
            highp vec2 coord_normalized = vec2( coord.x / (OutputSize.x - 1.0), coord.y / (OutputSize.y - 1.0) );
            
            highp vec4 color = texture2D(Texture, coord_normalized);
        
            highp float weight = exp(-(x*x+y*y) / varianceDist);
            
            totalWeight += weight;
            
            finalValue += color * weight;
        }
    }
    
    finalValue = finalValue / totalWeight;
    
    gl_FragColor = finalValue;
}

