#version 300 es

in highp vec2       Texcoord0;

uniform sampler2D   Texture;

out highp vec4      g_FragColor;

void main()
{
    highp vec4 color = texture(Texture, Texcoord0);
    
    highp float ll = color.r;
    highp float al = color.g;
    highp float be = color.b;
    
    highp float l = ll * 0.577324 + al *   0.408263  + be * 0.707114;
    highp float m = ll * 0.577324 + al *   0.408263  + be * -0.707114;
    highp float s = ll * 0.577324 + al * (-0.816526) + be * 0.0;
    
    l = exp (l);
    m = exp (m);
    s = exp (s);
    
    highp float x = (l * 1.91024  + m * (-1.11218) + s * 0.201941);
    highp float y = (l * 0.370942 + m * 0.629052   + s * 0.00000513315);
    highp float z = (l * 0.0      + m * 0.0        + s * 1.0);
    
    x = max(0.0, min(x, 32768.0));
    y = max(0.0, min(y, 32768.0));
    z = max(0.0, min(z, 32768.0));
    
    x = x/100.0;
    y = y/100.0;
    z = z/100.0;
    // xyz to rgb
    
    highp float r = x *  3.2406 + y * -1.5372 + z * -0.4986;
    highp float g = x * -0.9689 + y *  1.8758 + z *  0.0415;
    highp float b = x *  0.0557 + y * -0.2040 + z *  1.0570;
    
    if ( r > 0.0031308 )
    {
        r = 1.055 * ( pow(r, ( 1.0 / 2.4 )) ) - 0.055;
    }
    
    else
    {
        r = 12.92 * r;
    }
    
    if ( g > 0.0031308 )
    {
        g = 1.055 * ( pow(g, ( 1.0 / 2.4 )) ) - 0.055;
        
    }
    
    else
    {
        g = 12.92 * g;
    }
    
    if ( b > 0.0031308 )
    {
        b = 1.055 * ( pow(b, ( 1.0/ 2.4 ) )) - 0.055;
    }
    
    else
    {
        b = 12.92 * b;
    }
    
    g_FragColor.x = r;
    g_FragColor.y = g;
    g_FragColor.z = b;
    g_FragColor.w = 1.0;

}

