#version 300 es

in highp vec2       Texcoord0;

uniform sampler2D   Texture;

out highp vec4      g_FragColor;

void main()
{

    highp vec4 color = texture(Texture, Texcoord0);
    
    highp float fr = color.r;
    highp float fg = color.g;
    highp float fb = color.b;
    
    if ( fr > 0.04045 )
    {
        fr = pow(( ( fr + 0.055 ) / 1.055 ), 2.4);
    }
    
    else
    {
        fr = fr / 12.92;
    }
    
    if ( fg > 0.04045 )
    {
        fg = pow(( ( fg + 0.055 ) / 1.055 ), 2.4);
    }
    
    else
    {
        fg = fg / 12.92;
    }
    
    if ( fb > 0.04045 )
    {
        fb = pow(( ( fb + 0.055 ) / 1.055 ), 2.4 );
    }
    else
    {
        fb = fb / 12.92;
    }
    
    fr *= 100.0;
    fg *= 100.0;
    fb *= 100.0;
    
    highp float x = fr * 0.4124 + fg * 0.3576 + fb * 0.1805;
    highp float y = fr * 0.2126 + fg * 0.7152 + fb * 0.0722;
    highp float z = fr * 0.0193 + fg * 0.1192 + fb * 0.9505;
    
    // xyz to lab
    
    highp float l = x * 0.3897    +  y * 0.689   +  z * (-0.0787);
    highp float m = x * (-0.2298) +  y * 1.1834  +  z * 0.0464;
    highp float s = x * 0.0       +  y * 0.0       +  z * 1.0;
    
    l = (l <= 0.0 ? -1.0 : log (l));
    m = (m <= 0.0 ? -1.0 : log (m));
    s = (s <= 0.0 ? -1.0 : log (s));
    
    // Ruderman et al?color space (l alpha beta)
    
    highp float ll = l * 0.5774   + m * 0.5774    + s * 0.5774;
    highp float al = l * 0.4082   + m * 0.4082    + s * (-0.8165);
    highp float be = l * (0.7071) + m * (-0.7071) + s * 0.0;
    
    g_FragColor.x = ll;
    g_FragColor.y = al;
    g_FragColor.z = be;
    g_FragColor.w = 1.0;

}

