varying highp vec2      Texcoord0;

uniform  highp sampler2D MaskSAT;

uniform  highp vec2     InputSize;
uniform  highp vec2     OutputSize;

uniform  highp float    Radius;

void main()
{
    highp float radius = Radius;
    
    highp float w = OutputSize.x;
    highp float h = OutputSize.y;
    
    highp float w_raw = InputSize.x;
    highp float h_raw = InputSize.y;
    
    highp float finalAlpha = 0.0;
    highp float total_weight = 0.0;
    
    highp vec2 texelcoord = vec2(floor(w_raw*Texcoord0.r)+0.5, floor(h_raw*Texcoord0.g)+0.5);
    
    if(radius<1.0)
    {
        gl_FragColor = texture2D(MaskSAT, Texcoord0);
        
        return;
    }
    
    radius = floor(radius);
    
    highp float startx = max(0.0,texelcoord.x-radius);
    highp float starty = max(0.0,texelcoord.y-radius);
    highp float endx = min(w,texelcoord.x+radius);
    highp float endy = min(h,texelcoord.y+radius);
    
    highp float num = (endx-startx)*(endy-starty);
    
    startx  =   startx/w_raw;
    endx    =   endx/w_raw;
    starty  =   starty/h_raw;
    endy    =   endy/h_raw;
    
    highp float A = texture2D(MaskSAT, vec2(startx, endy)).r;
    highp float B = texture2D(MaskSAT, vec2(endx, starty)).r;
    highp float C = texture2D(MaskSAT, vec2(startx, starty)).r;
    highp float D = texture2D(MaskSAT, vec2(endx, endy)).r;
    
    highp float sum = D+C-A-B;
    
    gl_FragColor = vec4(sum/num, sum/num, sum/num, 1);
}
