#version 300 es
#extension GL_EXT_shader_framebuffer_fetch : require

in highp vec2 Texcoord0;
in highp vec2 Texcoord1;

uniform bool        WithMask;

uniform highp float Transparency;

// with adjustment
uniform sampler2D   Texture1;

uniform sampler2D   Mask;

layout(location = 0) inout highp vec4 g_FragColor;

void main()
{
    highp vec4 clr0 = g_FragColor;
    highp vec4 clr1 = texture(Texture1, Texcoord0);
    
    highp float alpha = clr1.a * Transparency;
    
    if(WithMask)
    {
        alpha = alpha * texture(Mask, vec2(Texcoord1.x, 1.0-Texcoord1.y)).r;
    }
    
    g_FragColor = clr0 * (1.0-alpha) + clr1 * alpha;
    g_FragColor.a = clr0.a;
}
