#version 300 es

in vec3 Position;
in vec3 Normal;
in vec2 Texcoord;
in vec2 Index;

out highp vec4 Position0;
out highp vec4 Normal0;
out highp vec2 Texcoord0;

uniform mat4x4 matWVP;
uniform mat4x4 matWorld;
uniform mat4x4 matNormal;

uniform sampler2D TextureMorphing;

void main()
{
    Position0 = matWorld*vec4(Position, 1.0);
    
    Texcoord0 = Texcoord;
    
    Normal0 = matNormal*vec4(Normal, 0.0);
    
    highp vec4 morphOffset = texture(TextureMorphing, Index);

    gl_Position = matWVP*morphOffset;
}
