#version 300 es

in highp vec2           Texcoord0;

uniform sampler2D       Mask;

uniform  highp vec2     OutputSize;

uniform  highp float    TrimapRadius;

out highp vec4          g_FragColor;

void main()
{
    mediump float ki = TrimapRadius;
    
    mediump float x = (OutputSize.x-1.0)*Texcoord0.x;
    mediump float y = (OutputSize.y-1.0)*Texcoord0.y;
    
    mediump vec4 hardseg = texture(Mask, Texcoord0);
    
    g_FragColor.r = hardseg.r;
    
    mediump float w = float(OutputSize.x);
    mediump float h = float(OutputSize.y);
    
    mediump float dist = 1e5;
    mediump float label = 0.5;
    
    mediump float xBegin = max(x-ki,0.0);
    mediump float yBegin = max(y-ki,0.0);
    
    mediump float xEnd = min(x+ki,w-1.0);
    mediump float yEnd = min(y+ki,h-1.0);
    
    bool added = false;
    mediump vec2 coord;
    
    mediump float a = hardseg.r;
    
    for (highp float  yy = yBegin; yy <= yEnd; ++yy)
    {
        for (highp float  xx = xBegin; xx <= xEnd; ++xx)
        {
            coord.x = xx / w;
            coord.y = yy / h;
            
            mediump vec4 temp = texture(Mask, coord);
            mediump float at = temp.r;
            
            //check if should be added
            if ( (a < 0.5 && at > 0.5) || (a > 0.5 && at < 0.5) )
            {
                //if (a != at)
                added = true;
                break;
            }
            
            ++xx;
        }
        yy+=2.0;
    }
    
    if (added)
    {
        g_FragColor.r = 0.5;
    }
}
