attribute vec3 Position;
attribute vec3 Normal;
attribute vec2 Texcoord;

uniform mat4 matWVP;
uniform mat4 matWorld;
uniform mat4 matNormal;
uniform mat4 matReflection;
uniform mat4 matReflectionNormal;

// position with reflection modifier
varying highp vec4 Position0;

// position without reflection modifier
varying highp vec4 Position1;

varying highp vec4 Normal0;
varying highp vec4 Normal1;
varying highp vec2 Texcoord0;

// for reflection offset
uniform sampler2D  ReflectionMask;
uniform highp vec4 EyePos;

void main()
{
    highp vec4 _normal = vec4(Normal,0.0);
    
    Normal0 = normalize(matNormal*_normal);
    Normal1 = matReflectionNormal*Normal0;
    
    Texcoord0 = Texcoord;
    
    Position0 = matWorld*vec4(Position,1.0);
    Position1 = matReflection*Position0;
    
    gl_Position = matWVP*vec4(Position,1.0);
}
