varying highp vec4 Position0;
varying highp vec2 Texcoord0;
varying highp vec4 Normal0;

uniform sampler2D Texture0;

highp float diffuseComponent(highp vec4 lightSourcePos, highp vec3 normal, highp vec4 pos)
{
    highp float _d = dot(normalize(lightSourcePos-pos), vec4(normal,0));
    
    return max(0.0, _d);
}

void main()
{
    highp vec4 ambient = texture2D(Texture0, Texcoord0);
    
    gl_FragColor = ambient*diffuseComponent(vec4(0, 0, 1000, 1.0), vec3(Normal0), Position0);
}