attribute vec3 Position;
attribute vec3 Normal;
attribute vec2 Texcoord;
attribute vec2 Index;

varying highp vec4 Position0;
varying highp vec4 Normal0;
varying highp vec2 Texcoord0;

uniform mat4 matWorld;
uniform mat4 matWVP;
uniform mat4 matNormal;

uniform sampler2D TextureMorphing;

void main()
{
    Position0 = matWorld*vec4(Position, 1.0);
    
    Texcoord0 = Texcoord;

    Normal0 = matNormal*vec4(Normal, 0.0);
    
    highp vec4 morphOffset = texture2D(TextureMorphing, Index);

    gl_Position = matWVP*morphOffset;
}
