#version 300 es

in vec3 Position;
in vec3 Normal;
in vec2 Texcoord;

uniform mat4x4 matWVP;
uniform mat4x4 matWorld;
uniform mat4x4 matNormal;
uniform mat4x4 matReflection;
uniform mat4x4 matReflectionNormal;

out highp vec4 Position0;
out highp vec4 Position1;
out highp vec4 Normal0;
out highp vec4 Normal1;
out highp vec2 Texcoord0;

void main()
{
    highp vec4 _normal = vec4(Normal,0.0);
    
    Normal0 = normalize(matNormal*_normal);
    Normal1 = matReflectionNormal*Normal0;
    
    Texcoord0 = Texcoord;
    
    Position0 = matWorld*vec4(Position,1.0);
    Position1 = matReflection*Position0;
    
    gl_Position = matWVP*vec4(Position,1.0);
}

