#version 300 es

in highp vec4 Position0;
in highp vec4 Normal0;
in highp vec2 Texcoord0;

uniform highp mat4x4    matInvWVP;
uniform highp float     Transparency;

uniform samplerCube     ReflectionMap;
uniform sampler2D       RefractionMap;

uniform highp vec2      ViewportSize;
uniform highp vec3      Color;

out highp vec4 g_FragColor;

void main()
{
    const highp float EPSILON = 0.001;
    
    highp vec3 lookatDir = vec3(matInvWVP*vec4(gl_FragCoord.x, gl_FragCoord.y, 0, 1.0));
    //lookatDir = normalize(lookatDir);
    
    highp vec3 normal = vec3(Normal0);
    
    highp vec3 reflectDir = reflect(lookatDir, normal);
    highp vec3 refractDir = refract(lookatDir, normal, 1.0/1.3);
    
    highp vec4 reflectionColor = texture(ReflectionMap, reflectDir);
    
    //------------------------------------------------------------------------------------------
    // check if it is within the reflection mask
    highp vec2 _texcoord = vec2(gl_FragCoord.x/ViewportSize.x, gl_FragCoord.y/ViewportSize.y);
    
    highp vec4 refractionColor = texture(RefractionMap, _texcoord)*0.5+texture(ReflectionMap, refractDir)*0.5;
    //------------------------------------------------------------------------------------------
    
    g_FragColor = vec4(Color, 1.0)*(1.0-Transparency)+reflectionColor*Transparency*0.7+refractionColor*Transparency*0.3;
}
