
// ui_2d_element_render.vsh

attribute vec4 position;
attribute vec4 normal;
attribute vec2 texCoord;

uniform mat4 matWVP;
uniform mat4 imgTexMat;
uniform mat4 oldImgTexMat;
uniform mat4 maskTexMat;

varying highp vec2 texCoordOut;
varying highp vec2 imgTexCoordOut;
varying highp vec2 oldTexCoordOut;
varying highp vec2 maskTexCoordOut;

void main()
{
    gl_Position = matWVP * position;
    
    texCoordOut = texCoord;
    
    highp vec4 texCoordV4;
    texCoordV4.xy = texCoord.xy;
    texCoordV4.z = 0.0;
    texCoordV4.w = 1.0;
    
    imgTexCoordOut.xy = (imgTexMat * texCoordV4).xy;
    oldTexCoordOut.xy = (oldImgTexMat * texCoordV4).xy;
    maskTexCoordOut.xy = (maskTexMat * texCoordV4).xy;
}
