
// ui_2d_element_render.fsh

varying highp vec2  texCoordOut;
varying highp vec2  imgTexCoordOut;
varying highp vec2  oldTexCoordOut;
varying highp vec2  maskTexCoordOut;

uniform highp float alpha;

uniform sampler2D   texture0;
uniform sampler2D   texture1;

uniform highp vec2  clipLeftTop;
uniform highp vec2  clipRightBottom;

uniform int         needStencil;
uniform sampler2D   stencilTex;
uniform highp vec2  stencilTexSize;
uniform int         renderIndexFirst;
uniform int         renderIndexLast;

void main()
{
    /*
    highp mat3 colorConversionMatrix;
    colorConversionMatrix[0] = vec3(1.164,  1.164, 1.164);
    colorConversionMatrix[1] = vec3(0.0, -0.213, 2.112);
    colorConversionMatrix[2] = vec3(1.793, -0.533,   0.0);
    */
    
    highp vec3 yuv;
    yuv.x = texture2D(texture0, imgTexCoordOut).r;
    yuv.yz = texture2D(texture1, imgTexCoordOut).ra - vec2(0.5, 0.5);
    gl_FragColor.r = yuv.x * 1.164 + yuv.z * 1.793;
    gl_FragColor.g = yuv.x * 1.164 + yuv.y * -0.213 + yuv.z * -0.533;
    gl_FragColor.b = yuv.x * 1.164 + yuv.y * 2.112;
    gl_FragColor.a = alpha;
    
    if (needStencil == 1)
    {
        highp vec2 coord;
        coord.x = gl_FragCoord.x / stencilTexSize.x;
        coord.y = gl_FragCoord.y / stencilTexSize.y;
        highp vec4 c = texture2D(stencilTex, coord, 0.0);
        
        int index = int(c.r * 100.0 + 0.5) + int(c.g * 100.0 + 0.5) * 100 + int(c.b * 100.0 + 0.5) * 10000;
        if (index < renderIndexFirst || index > renderIndexLast)
        {
            gl_FragColor.a = 0.0;
        }
    }
    else
    {
        gl_FragColor.a = gl_FragColor.a * float(texCoordOut.x >= clipLeftTop.x && texCoordOut.x <= clipRightBottom.x && texCoordOut.y >= clipRightBottom.y && texCoordOut.y <= clipLeftTop.y);
    }

    return;
}