#version 300 es

in highp vec2       texCoordOut;
in highp vec2       imgTexCoordOut;
in highp vec2       oldTexCoordOut;
in highp vec2       maskTexCoordOut;

uniform highp vec4  bgColor;
uniform highp float alpha;

uniform sampler2D   maskTexture;

uniform highp vec2  clipLeftTop;
uniform highp vec2  clipRightBottom;

uniform int         needStencil;
uniform sampler2D   stencilTex;
uniform highp vec2  stencilTexSize;
uniform int         renderIndexFirst;
uniform int         renderIndexLast;

out highp vec4      g_FragColor;

void main()
{
    g_FragColor = bgColor;
    
    g_FragColor.a = texture(maskTexture, maskTexCoordOut).a * g_FragColor.a;
    
    g_FragColor.a = alpha * g_FragColor.a;
    
    if (needStencil == 1)
    {
        highp vec2 coord;
        coord.x = gl_FragCoord.x / stencilTexSize.x;
        coord.y = gl_FragCoord.y / stencilTexSize.y;
        highp vec4 c = texture(stencilTex, coord, 0.0);
        
        int index = int(c.r * 100.0 + 0.5) + int(c.g * 100.0 + 0.5) * 100 + int(c.b * 100.0 + 0.5) * 10000;
        if (index < renderIndexFirst || index > renderIndexLast)
        {
            g_FragColor.a = 0.0;
        }
    }
    else
    {
        g_FragColor.a = g_FragColor.a * float(texCoordOut.x >= clipLeftTop.x && texCoordOut.x <= clipRightBottom.x && texCoordOut.y >= clipRightBottom.y && texCoordOut.y <= clipLeftTop.y);
    }
}