#version 300 es

// ui_2d_element_render.fsh

in highp vec4       colorVarying;
in highp vec2       texCoordOut;
in highp vec2       imgTexCoordOut;
in highp vec2       oldTexCoordOut;
in highp vec2       maskTexCoordOut;

uniform highp float alpha;

uniform sampler2D   texture0;
uniform sampler2D   texture1;

uniform highp vec2  clipLeftTop;
uniform highp vec2  clipRightBottom;

uniform int         needStencil;
uniform sampler2D   stencilTex;
uniform highp vec2  stencilTexSize;
uniform int         renderIndexFirst;
uniform int         renderIndexLast;

out highp vec4      g_FragColor;

void main()
{
    highp vec3 yuv;
    yuv.x = texture(texture0, imgTexCoordOut, 0.0).r;
    yuv.yz = texture(texture1, imgTexCoordOut, 0.0).ra - vec2(0.5, 0.5);
    g_FragColor.r = yuv.x * 1.164 + yuv.z * 1.793;
    g_FragColor.g = yuv.x * 1.164 + yuv.y * -0.213 + yuv.z * -0.533;
    g_FragColor.b = yuv.x * 1.164 + yuv.y * 2.112;
    g_FragColor.a = alpha;
    
    if (needStencil == 1)
    {
        highp vec2 coord;
        coord.x = gl_FragCoord.x / stencilTexSize.x;
        coord.y = gl_FragCoord.y / stencilTexSize.y;
        highp vec4 c = texture(stencilTex, coord, 0.0);
        
        int index = int(c.r * 100.0 + 0.5) + int(c.g * 100.0 + 0.5) * 100 + int(c.b * 100.0 + 0.5) * 10000;
        if (index < renderIndexFirst || index > renderIndexLast)
        {
            g_FragColor.a = 0.0;
        }
    }
    else
    {
        g_FragColor.a = g_FragColor.a * float(texCoordOut.x >= clipLeftTop.x && texCoordOut.x <= clipRightBottom.x && texCoordOut.y >= clipRightBottom.y && texCoordOut.y <= clipLeftTop.y);
    }
    
    return;
}